FROM docker.io/rustlang/rust:nightly AS chef
WORKDIR /app
RUN cargo install cargo-chef && rm -rf $CARGO_HOME/registry/

FROM chef AS planner
COPY . .
RUN cargo chef prepare --recipe-path recipe.json

FROM chef AS builder
COPY --from=planner /app/recipe.json recipe.json
# Build dependencies - this is the caching Docker layer!
RUN cargo chef cook --release --recipe-path recipe.json
# Build application
COPY . .
RUN cargo build --release --bin phono-server

# We do not need the Rust toolchain to run the binary!
FROM debian:bookworm-slim AS runtime
RUN apt-get update && apt-get install -y libpq-dev ca-certificates

# User should be set by UID to make the K8s `runAsNonRoot` check's job easier.
RUN useradd -m -u 1000 app
USER 1000

WORKDIR /home/app
COPY --from=builder /app/target/release/phono-server /usr/local/bin

COPY ./js_dist ./js_dist
COPY ./static ./static

ENTRYPOINT ["/usr/local/bin/phono-server"]
